<?php


class TelegramBot
{

    protected $token;
    protected $base_url = 'https://api.telegram.org/bot';
    public $update_id;

    public function __construct($token)
    {
        $this->token = $token;
        $this->base_url .= $token . '/';
    }

    public function sendRequest($method, $params = [])
    {
        $url = $this->base_url . $method;
        if (!empty($params)) {
            $url .= '?' . http_build_query($params);
        }
        return json_decode(file_get_contents($url));
    }

    public function getUpdates()
    {
        $params = [];
        if (!empty($this->update_id)) {
            $params = [
                'offset' => $this->update_id + 1,
            ];
        }
        $res = ($this->sendRequest('getUpdates', $params))->result;
        if (!empty($res)) {
            $this->update_id = $res[count($res) - 1]->update_id;
        }
        return $res;
    }

    public function sendMessage($chat_id, $text, $params = [])
    {
        return $this->sendRequest('sendMessage', array_merge([
            'chat_id' => $chat_id,
            'text' => $text,
        ], $params));
    }

    public function sendPhoto($chat_id, $photo, $params = [])
    {
        $url = $this->base_url . "sendPhoto";

        file_put_contents(__DIR__ . '/tmp.jpg', file_get_contents($photo));

        $post_fields = array_merge([
            'chat_id'   => $chat_id,
            'photo'     => new CURLFile(realpath(__DIR__ . '/tmp.jpg'))
        ], $params);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "Content-Type:multipart/form-data"
        ));
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_fields);
        $output = curl_exec($ch);
        return json_decode($output);

        /*return $this->sendRequest('sendPhoto', array_merge([
            'chat_id' => $chat_id,
            'photo' => $photo,
        ], $params));*/
    }

}